
'   O2 
'   alias Oxygen    :D 

'   Compiler for structured machine code
'
'------------------------------------------------------------------------

'   11:58 17/Mar/2008
'   Charles E V Pegge
'   Using FreeBasic .183
'------------------------------------------------------------------------



' pass location of code and location of data space:

function caller( byval p as byte pointer, byval q as byte pointer) as uinteger
 asm
  mov eax, [p]
  mov ebx, [q]
  call eax             ' call to the afdress contained in eax
  mov [function],eax   ' assume eax contains something meaningful and return it
 end asm               '
end function


'------------------------------------------------------------------------

'pass the source string to this function and obtain a binary coding:

'-------------------------------------

    #include "O2fun.bas"





function peeks(byval v as any ptr , l as long) as string
dim as string s=string$(l,chr$(0))
dim as long i=0
dim as byte ptr j=v
do
    if i>=l then function=s: exit function
    s[i]=peek(j): j+=1:i+=1
loop
end function



function displayhex(s as string) as string
    dim as long c=0,i=0,j=3,l=len(s)
    dim as string t=chr$(13)+chr$(10)+space(l*3.125 +1)
    do
        i+=1:if i>l then exit do
        mid$(t,j)=right$("0"+hex$(asc(s,i)),2):j+=3:c+=1
        if c>15 then c=0:mid$(t,j)=chr$(13)+chr$(10):j+=2
    loop
    function=left$(t,j-1)
end function


function displayoct(s as string) as string
    dim as long c=0,i=0,j=3,l=len(s)
    dim as string t=chr$(13)+chr$(10)+space(l*4.125 +1)
    do
        i+=1:if i>l then exit do
        mid$(t,j)=right$("00"+oct$(asc(s,i)),3):j+=4:c+=1
        if c>15 then c=0:mid$(t,j)=chr$(13)+chr$(10):j+=2
    loop
    function=left$(t,j-1)
end function




dim as string s,w,src,crz=chr$(10)+chr$(13)
dim as long ert,i,f1=freefile


if (command$="")or(asc(command$)=63) then
    print "O2 opcode compiler. Version 0.0  12 Mar 2008"
    print "Usage: O2 filename":print
    print "Instruction set:"
    print " ------------------------------------------------------------------------"
    print "   INSTRUCTION SET"
    print " ------------------------------------------------------------------------"
    print " all words are delimited by white space or comment mark"
    print "   '        comment to end of line"
    print "   [..]     string literal (the square brackets are nestable)"
    print "   .label   forward labels (only the first 2 letters are significant)"
    print "   :        make entry in jump table"
    print "   $        make space (value in hexadecimal)"
    print "   $$        make space & align to nearest 4 bytes"
    print "   2 digits  0-9 a-f hexadecimal byte "
    print "   3 digits  0-7 octal byte "
    print "   g         short forward relative jump (but not into an inner block)"
    print "   gl        long forward relative jump  (ditto)"
    print "   (         start of block"
    print "   )         end of block"
    print "   x         short jump exit from block"
    print "   xl        long jump exit from block"
    print "   r         short jump repeat from start of block"
    print "   rl        long jump repeat from start of block"
    print "   h         hexadecimal numbers:"
    print "   hw            word:   2 byte integer"
    print "   hl            long:   4 byte integer"
    print "   n         decimal numbers:"
    print "   nb            byte    1 byte"
    print "   nw            word:   2 byte integer"
    print "   nl            long:   4 byte integer"
    print "   nq            quad:   8 byte integer"
    print "   ns            single: 4 byte floating point"
    print "   nd            double: 8 byte floating point"
    print " "
    print " ------------------------------------------------------------------------"

    end
end if 
err=0
open command$ for binary access read as #f1
if err then print "Unable to locate source: "+command$:close:end
src=space(lof(f1)): get$ #f1,,src
close #f1

s=hexlink(src,ert,i)
w=string$(1000,chr$(0))

print "Length: ";len(s)
print

print "Coding: ";displayhex(s): print

if ert then
    if ert<1000000 then print left$(src,i) else print "Reference ";chr$(ert-1000000)
    print "Error:   ";ert
    print "location: ";i
end if



' execute source in s with shared table in w

if ert=0 then print "Return:  0x";hex$(caller(strptr(s),strptr(w)))


print "end"
end
